#include <stdio.h>
#include "rs232.h"
#include "globals.h"
#include "Graphics_Functions.h"
#include <time.h>



int main(int argc, char **argv)
{
	
	int error;
	int test_num = -3;
	printf("args %i\n",argc);
	if(argc > 1)
		test_num = atoi(argv[1]);
	printf("Serial Communication in C\n");
	
	printf("Opening Comport: COM1\n");
	error = OpenComport(0, 115200);
	if(error) {
		printf("Failed!!! Exiting\n");
		return 0;
	}
	unsigned char result;
	result = 0;
	int gray = 1;
	while(gray == 1 && test_num != 24)
		gray = PollComport(0,&result,1); //to flush out initial data
	
	
	clock_t start;
	float elapsed_time;
	float num_instr;
	float instr_per_sec;
	
	
	
	//White Rectangle to clear screen
	//fillRectangle(0,0,320,240,15,15,15);
	//fillRectangle(0,0,320,240,15,15,15);
	
	//for(gray = 1; gray < 100; gray ++)
	{
	//setDrawMode(M8bit_SINGLE_640x480);
	//fillCircle(160,120,100,15,0,0);
	/*int gray = 0;
	while(gray == 0){
		gray = PollComport(0,&result,1); //to flush out initial data
		printf("waiting: %i, %i\n",gray, result);
		}*/
	//fillRectangle(100,100,50,50,0,0,15);
	//fillCircle(100,100,25,0,15,0);
	/*
	drawChar(160,120,16,15,15,15);
	drawString(100,100,"HELLO",15,15,15);
	if(argc > 2)
		drawString(10,30,argv[2],0,12,0);*/
	}
	
	
	
	
	if(test_num == 1 || test_num == 99)
	{
	printf("************STARTING SQUARE DRAW BENCHMARKS 1*****************\n");
	
	start = clock();
	
	int r = 0;
	int g = 0;
	int b = 0;
	
	for(r = 0; r < 15; r ++)
		for(g = 0; g < 15; g ++)
			for(b = 0; b < 15; b ++)
				fillRectangle(r*20,g*15,20,14,r,g,b);
	
	elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
	printf("Time elapsed: %f\n", elapsed_time);
	
	num_instr = 15*15*15;
	
	instr_per_sec = num_instr / elapsed_time;
	
	printf("Ops per Sec: %f\n",instr_per_sec);
	
	printf("-----------------------------------------------------\n");
	}
	if(test_num == 2 || test_num == 99)
	{
	printf("************STARTING FULL SCREEN BENCHMARKS 2*****************\n");
	
	start = clock();
	int r = 0;
	int g = 0;
	int b = 0;
	
	for(r = 0; r < 15; r ++)
		for(g = 0; g < 15; g ++)
			for(b = 0; b < 15; b ++)
				fillRectangle(0,0,315,235,r,g,b);
	
	elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
	printf("Time elapsed: %f\n", elapsed_time);
	
	num_instr = 15*15*15;
	
	instr_per_sec = num_instr / elapsed_time;
	
	printf("Ops per Sec: %f\n",instr_per_sec);
	
	printf("-----------------------------------------------------\n");
	}
	
	if(test_num == 3 || test_num == 99)
	{
	printf("************STARTING Frame TEST BENCHMARKS *****************\n");
	
	start = clock();
	num_instr = 0;
	elapsed_time = 0;
	
	int x1 = 0;
	int x2 = 0;
	int y1 = 0;
	int y2 = 0;
	
	int x3 = 320;
	int x4 = 320;
	int y4 = 240;
	int y3 = 240;
	
	int dx1 = 1;
	int dx3 = -1;
	int dy2 = 1;
	int dy4 = -1;
	
	int rad;
	
	float weird = 0;
	int i;
	while(elapsed_time < 15)
	{
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		fillRectangle(0,0,320,240,15,15,15);
		
		for(i = 20; i < 220; i += 20)
		{
			//drawRectangle(0,i+(int)weird,320,10,0,10,0);
			//drawRectangle(0,i+(int)weird+10,320,10,0,0,0);
		}
		for(i = 1; i < 1000; i ++)
			drawLine((int)(rand()*180),(int)(rand()*80),(int)(20+rand()*60),(int)(20 + rand()*60),(int)(rand()*15),(int)(rand()*15),(int)(rand()*15));
		
		weird += .1;
		if(weird >= 20) weird = 0;
		/*x1 += dx1;
		y2 += dy2;
		
		
		
		if(x1 == 320 || x1 == 0) dx1 *= -1;
		if(y2 == 240 || y2 == 0) dy2 *= -1;
		
		drawLine(x1,y1,x2,y2,x1 % 15,0,(int)elapsed_time % 15);
		//drawLine(320-x1,240,320,240-y2, 7, y2%15, (int)elapsed_time % 15);
		
		rad = 5*elapsed_time;
		fillCircle(200,100,rad,15,0,5);
		*/
		
		
		
		num_instr ++;
	}
	
		
	
	printf("Time elapsed: %f\n", elapsed_time);
	
	//num_instr = 15*15*15;
	
	instr_per_sec = num_instr / elapsed_time;
	
	printf("Frames per Sec: %f\n",instr_per_sec);
	
	printf("-----------------------------------------------------\n");
	}
	
	if(test_num == 4){
		start = clock();
		num_instr = 0;
		elapsed_time = 0;
		
		int ballx = 100;
		int bally = 100;
		int accum = 0;
		int i;
		fillRectangle(0,0,320,240,15,15,15);
		while(elapsed_time < 15)
		{
			elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
			
			
			fillCircle(ballx,bally,50,15,15,15);
			
			ballx ++;
			fillCircle(ballx,bally,50,0,0,0);
			if(ballx > 260) ballx = 55;
			
			for(i = 0; i < 50000000; i ++)
				accum ++;
			
			
			}
	
	
	}
	if(test_num == 5) //command prompt demo
	{
		setDrawMode(M8bit_SINGLE_640x480);
		fillRectangle(0,0,320,240,0,0,0);
		
		char input[40];
		int quit = 0;
		int numInputs = 0;
		
		while(~quit)
		{
			scanf("%s",&input);
			
			//frameUpdate();
			drawString(10,numInputs*8+10,input,0,10,0);
			
			
			numInputs ++;
		}
		
		
		
	}
	if(test_num == 6) //frame test
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		fillRectangle(0,0,320,240,0,10,0);
		fillCircle(100,100,40,5,5,5);
		fillRectangle(200,200,20,20,15,0,0);
		frameUpdate();
		fillRectangle(0,0,320,240,0,0,15);
		fillCircle(200,200,20,10,10,10);
		fillRectangle(100,100,10,10,10,10,10);/*
		frameUpdate();*/
	}
	if(test_num == 7) //frame buffer
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		
		int bx = 100;
		int by = 100;
		int bdx = 1;
		int bdy = 1;
		int rad = 20;
		fillRectangle(0,0,320,240,0,0,0);
		frameUpdate();
		fillRectangle(0,0,320,240,0,0,0);
		frameUpdate();
		while(1){
			fillCircle(bx,by,rad+1,0,0,0);
			bx += bdx;
			by += bdy;
			if(bx >= (320-rad-1) || bx <= 0) bdx *= -1;
			if(by >= (240-rad-1) || by <= 0) bdy *= -1;
			
			
			fillCircle(bx,by,rad,10,0,0);
			frameUpdate();
		}
		
		
	}
	if(test_num == 8) //320x240 frame buffer slow
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		fillRectangle(0,0,320,240,15,0,0);
		fillCircle(100,100,20,15,0,0);
		frameUpdate();
		fillRectangle(0,0,320,240,0,15,0);
		char input[40];
		int k = 0;
		int x = 20;
		for(k = 0; k < 10; k ++){
			scanf("%s",&input);
			frameUpdate();
			if( (k % 2) == 0)
			{
				fillRectangle(0,0,320,240,(x%10),(x%10),2);
				fillRectangle(x,50,20,20,0,0,15);
				x += 25;
			}
			else {
				fillRectangle(0,0,320,240,(x%15),(x%15),15);
				fillRectangle(x,100,25,25,0,0,10);
				x += 40;
			}
		}
	}
	if(test_num == 9)
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		int k = 0;
		int hold = 0;
		int i = 0;
		char input[40];
		for(k = 0; k < 1000; k ++)
		{frameUpdate();
			for(i = 0; i < 24; i ++)
				fillRectangle(0,i*10,250,10,0,15,k%15);
			
			
			
			
			//fillRectangle((k%100)+50,100+k/10,20,20,15,10,0);
			//built in pause
			//for(i = 0; i < 1000000; i ++)
			//	hold ++;
			printf("hold: %i\n",hold);
			
			scanf("%s",&input);
		}
		
	}
	if(test_num == 10)
	{
		setDrawMode(M16bit_SINGLE_320x240);
		int k = 0;
		int hold = 0;
		int i = 0;
		char input[40];
		for(k = 0; k < 1000; k ++)
		{
			
			fillRectangle(0,0,250,200,0,15,0);
			
			
			fillRectangle((k%100)+50,100,25,25,15,0,0);
			
			//fillRectangle((k%100)+50,100+k/10,20,20,15,10,0);
			//built in pause
			
			//scanf("%s",&input);
		}
		
	}
	if(test_num == 11)
	{
		setDrawMode(M16bit_SINGLE_320x240);
		int k = 0;
		int hold = 0;
		int i = 0;
		char input[40];
		for(k = 0; k < 1000; k ++)
		{
			for(i = 0; i < 24; i ++)
				fillRectangle(0,i*10,250,10,0,15,k%15);
			
			
			
			
			//fillRectangle((k%100)+50,100+k/10,20,20,15,10,0);
			//built in pause
			//for(i = 0; i < 1000000; i ++)
			//	hold ++;
			printf("hold: %i\n",hold);
			frameUpdate();
			//scanf("%s",&input);
		}
		
	}
	if(test_num == 12) //test the transmitter
	{
		int i = 0;
		for(i = 0; i < 50000; i ++){
			int pollResult = 0;
			while(pollResult == 0){
				pollResult =PollComport(0,&result,1);
				printf("Waiting...");
				printf("\r");
			}
			printf("\n%i: Received: %d\n",i,result);
		}
		
		
	}
	if(test_num == 13)
	{
		setDrawMode(M16bit_SINGLE_320x240);
		fillRectangle(0,0,300,20,15,0,0);
		fillRectangle(0,20,300,20,15,0,0);
		fillRectangle(0,40,300,20,15,0,0);
		frameUpdate();
		fillRectangle(0,60,300,20,15,0,0);
		fillRectangle(0,80,300,20,15,0,0);
	}
	if(test_num == 14)
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		int k = 0;
		int hold = 0;
		int i = 0;
		char input[40];
		for(k = 0; k < 1000; k ++)
		{
			
			fillRectangle(0,0,250,200,0,15,0);
			
			
			fillRectangle((k%100)+50,100,25,25,15,0,0);
			frameUpdate();
			//fillRectangle((k%100)+50,100+k/10,20,20,15,10,0);
			//built in pause
			
			//scanf("%s",&input);
		}
		
	}
	if(test_num == 15)
	{
		setDrawMode(M4bit_DOUBLE_640x480);
		int k = 0;
		int hold = 0;
		int i = 0;
		char input[40];
		for(k = 0; k < 1000; k ++)
		{
			
			fillRectangle(0,0,250,200,0,15,0);
			
			
			fillRectangle((k%100)+50,100,25,25,15,0,0);
			frameUpdate();
			//fillRectangle((k%100)+50,100+k/10,20,20,15,10,0);
			//built in pause
			
			//scanf("%s",&input);
		}
		
	}
	
	if(test_num == 16) { //testing all graphics functions
		char input[40];
		int i,j,k;
		
		//first test 320x240 single buffered
		int w = 320;
		int h = 240;
		for(i = 0; i < 2; i ++){
			if(i == 0)	
				setDrawMode(M16bit_SINGLE_320x240);
			if(i == 1)	
				setDrawMode(M8bit_SINGLE_640x480);
			//Blank The Screen to white
			fillRectangle(0,0,w,h,15,15,15);
				//Square Fill Test
				fillRectangle(10,10,60,30,15,0,0);
				fillRectangle(200,50,10,150,0,15,0);
				fillRectangle(50,200,200,35,0,0,15);
			scanf("%s",&input);
			//Blank the screen to white
			fillRectangle(0,0,w,h,15,15,15);
				//Circle Fill Test
				fillCircle(100,100,60,15,0,0);
				fillCircle(200,50,10,0,15,0);
				fillCircle(50,200,35,0,0,15);
			scanf("%s", &input);
			//Blank the screen to white
			fillRectangle(0,0,w,h,15,15,15);
				//Square Draw Test
				drawRectangle(10,10,60,30,15,0,0);
				drawRectangle(200,50,10,150,0,15,0);
				drawRectangle(50,200,200,35,0,0,15);
			scanf("%s", &input);
			//Blank the screen to white
			fillRectangle(0,0,w,h,15,15,15);
				//Circle Draw Test
				drawCircle(100,100,60,15,0,0);
				drawCircle(200,50,10,0,15,0);
				drawCircle(50,200,35,0,0,15);
			scanf("%s", &input);
			//Blank the screen to white
			fillRectangle(0,0,w,h,15,15,15);
				//Draw line test
				drawLine(10,100,10,200,15,0,0);
				drawLine(100,10,100,50,0,15,0);
				drawLine(160,160,10,210,0,0,15);
			scanf("%s", &input);
			//Blank the screen to white
			fillRectangle(0,0,w,h,15,15,15);
				//String test
				drawString(100,100,"PETER",0,15,0);
				drawString(100,110,"MENG",0,15,0);
				drawString(145,110,"PROJECT",0,15,0);
				drawRectangle(98,98,105,24,0,0,0);
			scanf("%s", &input);
			//Blank the screen to white
			fillRectangle(0,0,w,h,15,15,15);
			w*= 2;
			h*= 2;
		}
	}
	if(test_num == 17) //test 640x480 
	{
		setDrawMode(M8bit_SINGLE_640x480);
		fillRectangle(0,0,640,480,0,15,0);
		drawLine(100,400,100,400,0,15,0);
		drawLine(100,200,101,101,15,0,0);
		drawLine(100,400,102,400,0,0,15);
		drawLine(100,200,103,103,0,15,0);
		
		fillRectangle(400,400,40,40,0,0,15);
		fillRectangle(0,420,640,10,0,15,0);
		fillRectangle(100,5,10,450,15,0,0);
	}
	if(test_num == 18) //bouncing ball test
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		int i = 0;
		int bx = 100;
		int by = 100;
		int r = 30;
		int dx = 5;
		int dy = 5;
		
		for(i = 0; i < 1000; i ++)
		{
			bx += dx;
			by += dy;
			if(bx <= r || bx >= (320-r)) dx *= -1;
			if(by <= r || by >= (240-r)) dy *= -1;
			
			fillRectangle(0,0,320,240,15,15,15);
			fillCircle(bx,by,r,0,15,0);
			frameUpdate();
		}
	}
	if(test_num == 19) //program gets stuck test (is CRC fault?)
	{
		setDrawMode(M16bit_SINGLE_320x240);
		int i,j,k;
		k = 15;
		int count = 0;
		for(i = 0; i < 320-k; i ++)
		{
			for(j = 0; j < 240-k; j ++)
			{
				count ++;
				printf("PID: %i %i\n",count, count%256);
				fillRectangle(i,j,k,k,i%15,k,j%15);
			}
		}
	}
	if(test_num == 20) // test the circle drawing algorithm
	{
		setDrawMode(M16bit_SINGLE_320x240);
		fillCircle(100,100,60,15,0,0);
		fillCircle(200,50,10,0,15,0);
		fillCircle(50,200,35,0,0,15);
		
		fillRectangle(240,50,50,50,0,0,0);
		drawRectangle(240,110,50,60,0,15,0);
		
		
		fillCircle(265,65,40,0,0,15);
		fillRectangle(240,111,70,30,0,0,15);
		
		
		
		
	}
	
	if(test_num == 21) //test if the fills work correctly
	{
		setDrawMode(M16bit_SINGLE_320x240);
		fillRectangle(0,0,320,80,15,0,0);
		fillRectangle(0,80,320,80,0,15,0);
		fillRectangle(0,160,320,80,0,0,15);
		
		fillCircle(100,100,60,15,15,15);
		fillCircle(200,50,10,15,15,0);
		fillCircle(50,200,35,0,15,15);
	}
	if(test_num == 22) //test if it is the frameUpdate that causes the stall (@ 320x240)
	{
		setDrawMode(M16bit_SINGLE_320x240);
		int i,j,k;
		k = 15;
		int count = 0;
		for(i = 0; i < 320-k; i ++)
		{
			for(j = 0; j < 240-k; j ++)
			{
				count ++;
				printf("PID: %i %i\n",count, count%256);
				fillRectangle(i,j,k,k,i%15,k,j%15);
				frameUpdate();
			}
			//frameUpdate();
		}
	}
	if(test_num == 23) //test if it is the frameUpdate that causes the stall (@ 320x240)
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		int i,j,k;
		k = 15;
		int count = 0;
		for(i = 0; i < 320-k; i ++)
		{
			for(j = 0; j < 240-k; j ++)
			{
				count ++;
				printf("PID: %i %i\n",count, count%256);
				fillRectangle(i,j,k,k,i%15,k,j%15);
				frameUpdate();
			}
			//frameUpdate();
		}
	}
	if(test_num == 24)
	{
		int pollResult = 0;
		while(pollResult == 0){
			pollResult =PollComport(0,&result,1);
			//printf(".");
		}
		printf("Safey: %d\n",result);
	}
	if(test_num == 25) //test the 640x480 graphics
	{
		setDrawMode(M8bit_SINGLE_640x480);
		fillRectangle(0,0,320,240,15,0,0);
		fillRectangle(320,240,320,240,15,0,0);
		fillRectangle(320,0,320,240,0,15,0);
		fillRectangle(0,240,320,240,0,0,15);
		fillCircle(320,240,100,15,15,15);
	}
	if(test_num == 26) //test the 640x480 graphics and framebuffer
	{
		setDrawMode(M4bit_DOUBLE_640x480);
		int i;
		int bx = 100;
		int by = 100;
		int dx = 10;
		int dy = 10;
		int r = 100;
		for(i = 0; i < 100; i ++)
		{
			if((i%2) == 0)
			{
				fillRectangle(0,0,320,240,15,0,0);
				fillRectangle(320,240,320,240,15,0,0);
				fillRectangle(320,0,320,240,0,15,0);
				fillRectangle(0,240,320,240,0,0,15);
				fillCircle(bx,by,r,15,15,15);
			}
			else
			{
				fillRectangle(0,0,320,240,0,15,0);
				fillRectangle(320,240,320,240,0,15,0);
				fillRectangle(320,0,320,240,0,0,15);
				fillRectangle(0,240,320,240,15,0,0);
				fillCircle(bx,by,r,15,0,15);
			}
			bx += dx;
			by += dy;
			if(bx <= r || bx >=(640-r)) dx *= -1;
			if(by <= r || by >=(480-r)) dy *= -1;
			frameUpdate();
		}
	}
	if(test_num == 27) //full screen frame buffer test
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		
		num_instr = 0;
		elapsed_time = 0;
		int i;
		start = clock();
		for(i = 0; i < 1000; i ++)
		{
			fillRectangle(0,0,320,240,i%15,i%15,i%15);
			frameUpdate();
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		printf("Packets Sent: 2000\n");
		printf("Packets_per_Second: %f\n",(2000/elapsed_time));
	}
	if(test_num == 28) //full screen frame buffer test
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 25; i ++)
		{
			for(j = 0; j < 150; j ++)
				drawLine(rand()*320,rand()*320,rand()*240,rand()*240,(int)(rand()*15),(int)(rand()*15),(int)(rand()*15));
			frameUpdate();
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		printf("Packets Sent: 2000\n");
		printf("Packets_per_Second: %f\n",(150*25*2/elapsed_time));
		printf("Frames Per Second: %f\n",(25/elapsed_time));
	}
	if(test_num == 29) //test new fonts
	{
		setDrawMode(M8bit_SINGLE_640x480);
		fillRectangle(0,0,640,480,0,0,0);
		
		char input[40];
		int quit = 0;
		int numInputs = 0;
		
		while(~quit)
		{
			scanf("%s",&input);
			
			//frameUpdate();
			drawString(10,numInputs*8+10,input,0,10,0);
			
			
			numInputs ++;
		}
	}
	if(test_num == 30)
	{
		setDrawMode(M4bit_DOUBLE_640x480);
		fillRectangle(0,0,640,480,0,15,0);
		frameUpdate();
		fillRectangle(0,0,640,480,0,15,0);
		frameUpdate();
		
		drawRectangle(100,100,500,350,0,0,0);
		drawString(300-8*6,140,"Hello World!",0,0,0);
		drawString(300-8*1,150,"by",0,0,0);
		drawString(300-8*7,170,"Peter Greczner",0,0,0);
		frameUpdate();
		
	}
	if(test_num == 31)
	{
		setDrawMode(M16bit_SINGLE_320x240);
		fillRectangle(0,0,320,200,0,15,0);
		fillRectangle(0,200,320,40,0,7,0);
		writeInstruction(100, 10, 20, 30, 40, 50, 60);
	}
	if(test_num == 32) //download test
	{
		startDownload();
		writeInstruction(0, 10, 20, 30, 40, 50, 60);
		writeInstruction(1, 10, 20, 30, 40, 50, 60);
		writeInstruction(2, 10, 20, 30, 40, 50, 60);
		//finishDownload();
	}
	if(test_num == 33) //ECE day 320x240
	{
		setDrawMode(M16bit_SINGLE_320x240);
		int red;
		int green;
		int blue;
		for(green = 0; green < 15; green ++)
		{
			for(red = 0; red < 15; red ++)
				drawLine(green*15+red,green*15+red,0,240,red, green, 0);
		}
		for(green = 0; green < 4; green ++)
			for(blue = 0; blue < 15; blue ++)
				drawLine(green*15+blue+255,green*15+blue+255,0,240,0,green,blue);
		/*		
		drawString(10,10,"ABCDEFGHIJKLMNOPQRSTUVWXYZ",0,0,0);*/
		//drawString(10,10,"abcdefghijklmnopqrstuvwxyz",15,15,15);
		/*
		drawString(10,20,"1234567890-_+=,<.>/?[]{}\\|",0,0,0);
		drawString(10,30,"!@#$%^&*()",0,0,0);*/
		
		drawString(100-8*6,140,"Hello World!",0,0,0);
		drawString(100-8*1,150,"by",0,0,0);
		drawString(100-8*7,170,"Peter Greczner",0,0,0);
		
		fillRectangle(200,25,60,30,0,0,15);
		fillRectangle(230,55,30,100,0,15,0);
		
		fillRectangle(200,100,100,100,15,15,15);
		fillCircle(250,150,50,8,8,9);
		drawCircle(250,150,25,0,15,0);
		drawCircle(250,150,12,0,7,0);
	}
	if(test_num == 34) //ECE day 640x480
	{
		setDrawMode(M8bit_SINGLE_640x480);
		int red;
		int green;
		int blue;
		
		fillRectangle(0,0,640,480,0,15,0);
		fillRectangle(0,0,640,480,0,15,0);
		
		for(green = 0; green < 15; green ++)
		{
			for(red = 0; red < 15; red ++)
				drawLine(green*15+red,green*15+red,0,240,red, green, 0);
		}
		for(green = 0; green < 4; green ++)
			for(blue = 0; blue < 15; blue ++)
				drawLine(green*15+blue+255,green*15+blue+255,0,240,0,green,blue);
		/*		
		drawString(10,10,"ABCDEFGHIJKLMNOPQRSTUVWXYZ",0,0,0);*/
		//drawString(10,10,"abcdefghijklmnopqrstuvwxyz",15,15,15);
		/*
		drawString(10,20,"1234567890-_+=,<.>/?[]{}\\|",0,0,0);
		drawString(10,30,"!@#$%^&*()",0,0,0);*/
		
		drawString(100-8*6,140,"Hello World!",0,0,0);
		drawString(100-8*1,150,"by",0,0,0);
		drawString(100-8*7,170,"Peter Greczner",0,0,0);
		
		fillRectangle(200,25,60,30,0,0,15);
		fillRectangle(230,55,30,100,0,15,0);
		
		fillRectangle(200,100,100,100,15,15,15);
		fillCircle(250,150,50,8,8,9);
		drawCircle(250,150,25,0,15,0);
		drawCircle(250,150,12,0,7,0);
		
		drawString(400,100,"640x480 Graphics",15,15,15);
		drawRectangle(395,95,16*8+10,20,8,0,0);
		
		//polygon
		int px[] = {100,100+(int)(rand()/(float)RAND_MAX*50.0), 100+(int)(rand()/(float)RAND_MAX*50.0)};
		int py[] = {400,400+(int)(rand()/(float)RAND_MAX*50.0), 400+50+(int)(rand()/(float)RAND_MAX*20.0)};
		
		drawPolygon(px,py,3,15,0,0);
		int z = 0;
		int i = 0;
		for(i = 0; i < 20; i ++)
		{
			int base_x = (int)(rand()/(float)RAND_MAX*400.0);
			int base_y = min(480,(int)(rand()/(float)RAND_MAX*200.0)+320);
			px[0] = base_x;
			py[0] = base_y;
			for(z = 1; z < 3; z ++)
			{
				px[z] = px[z-1] + (int)(rand()/(float)RAND_MAX*100.0);
				py[z] = min(py[z-1] + (int)(rand()/(float)RAND_MAX*100.0) - 50,480);
			}
			drawPolygon(px,py,3,i%15,0,i/4+4);
		}
		
		drawString(400,400,"abcdefghijklmnopqrstuvwxyz",0,0,15);
		
		for(i = 500; i < 800; i ++)
		{
			drawLine(400,i,410,480,i%15,i%10, i%5);
		}
		
		for(i = 5; i < 100; i += 3)
			drawRectangle(480-i/2,230-i/2,i,i,10,0,10);
		
	}
	if(test_num == 35) //draw a scene
	{
		setDrawMode(M8bit_SINGLE_640x480);
		
		fillRectangle(0,0,640,480,0,0,0);
		int sky = 0;
		int skyc = 15;
		double dskyc = 1.0/230.0;
		for(sky = 1; sky < 230; sky ++)
		{
			if((sky % 15) == 0) skyc --;
			drawLine(0,640,sky,sky,0,0,max(skyc,4));
			printf("(int)skyc: %i\n",skyc);
			
		}
		
		int grass = 0;
		int grassc = 0;
		double dgrassc = 1.0/250.0;
		for(grass = 230; grass <= 479; grass ++){
			if((grass % 15) == 0) grassc ++;
			drawLine(0,640,grass,grass,0,max(grassc,2),0);
			
			}
			
		fillRectangle(320-150,320-250,300,250,12,0,0);
		int brick = 0;
		for(brick = 320; brick >= (320-250); brick -=5)
		{
			drawLine(170,470,brick,brick,0,0,0);
			int x;
			for(x = 170 + ((brick%2)*10); x < 470; x += 15)
				if((rand()/(float)RAND_MAX) <= .5)
				{
					if(brick <= 315)
					{
						drawLine(x,x,brick,brick+5,0,0,0);
					}
				}
		}
		
		fillRectangle(320-150,320-250-25,300,25,0,0,0);
		fillRectangle(320-30,320-120,60,120,9,5,0);
		fillCircle(320+15,320-80,10,15,15,0);
		fillRectangle(320-120,320-225,50,50,15,15,15);
		drawRectangle(320-120,320-225,50,50,0,0,0);
		fillRectangle(320+80,320-225,50,50,15,15,15);
		drawRectangle(320+80,320-225,50,50,0,0,0);
		
		fillRectangle(500,400-165,65,165,9,5,0);
		fillCircle(533,400-165,80,0,12,0);
		
		fillRectangle(320-50,320,100,40,0,0,15);
		drawString(320-8*4,340,"Welcome!",15,15,8);
		
		
		int sun = 0;
		for(sun = 15; sun >= 8; sun --)
			fillCircle(100,40,sun*2,sun,sun,0);
			
		drawString(10,470,"Scene Demo - 640x480 - Peter Greczner",15,15,15);
		
	}
	
	if(test_num == 36) //full screen frame buffer test
	{
		
		setDrawMode(M8bit_SINGLE_640x480);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 100; i ++)
		{
			for(j = 0; j < 100; j ++)
				drawLine(rand()*640,rand()*640,rand()*480,rand()*480,(int)(rand()*15),(int)(rand()*15),(int)(rand()*15));
			//frameUpdate();
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		printf("Packets Sent: 2000\n");
		printf("Packets_per_Second: %f\n",(150*25*1/elapsed_time));
		printf("Frames Per Second: %f\n",(25/elapsed_time));
	}
	if(test_num == 37) //full screen frame buffer test
	{
		
		setDrawMode(M8bit_SINGLE_640x480);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 100; i ++)
		{
			fillRectangle(0,0,640,480,i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 38) //full screen frame buffer test
	{
		
		setDrawMode(M16bit_SINGLE_320x240);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 100; i ++)
		{
			fillRectangle(0,0,320,240,i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 39) //full screen frame buffer test
	{
		
		setDrawMode(M16bit_SINGLE_320x240);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 250; i ++)
		{
			fillRectangle(0,0,(int)(rand()/(float)RAND_MAX*320.0),(int)(rand()/(float)RAND_MAX*240.0),i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 40) //full screen frame buffer test
	{
		
		setDrawMode(M8bit_SINGLE_640x480);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 250; i ++)
		{
			fillRectangle(0,0,(int)(rand()/(float)RAND_MAX*640.0),(int)(rand()/(float)RAND_MAX*480.0),i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	
	if(test_num == 41) //full screen frame buffer test
	{
		
		setDrawMode(M8bit_SINGLE_640x480);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 1000; i ++)
		{
			fillRectangle(0,0,(int)(rand()/(float)RAND_MAX*64.0),(int)(rand()/(float)RAND_MAX*48.0),i%15,0,0);
			drawLine(0,0,(int)(rand()/(float)RAND_MAX*64.0),(int)(rand()/(float)RAND_MAX*48.0),i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 42) //full screen frame buffer test
	{
		
		setDrawMode(M16bit_SINGLE_320x240);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 1000; i ++)
		{
			fillRectangle(0,0,(int)(rand()/(float)RAND_MAX*32.0),(int)(rand()/(float)RAND_MAX*24.0),i%15,0,0);
			drawLine(0,0,(int)(rand()/(float)RAND_MAX*32.0),(int)(rand()/(float)RAND_MAX*24.0),i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 43) //full screen frame buffer test
	{
		
		setDrawMode(M16bit_SINGLE_320x240);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 5000; i ++)
		{
			
			drawLine(i%320,i%240,i%320,i%240,i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 44) //full screen frame buffer test
	{
		
		setDrawMode(M8bit_SINGLE_640x480);
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		for(i = 0; i < 5000; i ++)
		{
			frameUpdate();
			//drawLine(i%640,i%480,i%640,i%480,i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 45) //full screen frame buffer test
	{
		
		setDrawMode(M8bit_DOUBLE_320x240);
		
		fillRectangle(0,0,320,240,15,15,15);
		frameUpdate();
		fillRectangle(0,0,320,240,15,15,15);
		frameUpdate();
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		
		for(i = 0; i < 1000; i ++)
		{
			fillRectangle(i%300-12,88,24,24,15,15,15);
			fillCircle(i%300+10,100,10,0,0,0);
			frameUpdate();
			//drawLine(i%640,i%480,i%640,i%480,i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 46) //full screen frame buffer test
	{
		
		setDrawMode(M4bit_DOUBLE_640x480);
		
		fillRectangle(0,0,640,480,15,15,15);
		frameUpdate();
		fillRectangle(0,0,640,480,15,15,15);
		frameUpdate();
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		int k;
		for(i = 0; i < 1000; i ++)
		{
			for(k = 0; k < 10; k ++)
			{
				fillRectangle(i%600-12,88+k*12,24,24,15,15,15);
				fillCircle(i%600+10,100+k*12,10,0,0,0);
			}
			frameUpdate();
			//drawLine(i%640,i%480,i%640,i%480,i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 47) //full screen frame buffer test
	{
		
		setDrawMode(M8bit_DOUBLE_320x240);
		
		fillRectangle(0,0,320,240,15,15,15);
		frameUpdate();
		fillRectangle(0,0,320,240,15,15,15);
		frameUpdate();
		
		num_instr = 0;
		elapsed_time = 0;
		int i,j;
		start = clock();
		int k;
		for(i = 0; i < 1000; i ++)
		{
			for(k = 0; k < 10; k ++)
			{
				fillRectangle(i%300-12,88+k*12,24,24,15,15,15);
			fillCircle(i%300+10,100+k*12,10,0,0,0);
			}
			frameUpdate();
			//drawLine(i%640,i%480,i%640,i%480,i%15,0,0);
		}
		elapsed_time = ((double)clock() - start) / CLOCKS_PER_SEC;
		
		printf("Finished in %f seconds\n",elapsed_time);
		
	}
	if(test_num == 48)
	{
		setDrawMode(M8bit_SINGLE_640x480);
		
		fillRectangle(0,0,640,480,7,0,0);
		drawString(10,50,"Text Writing Demo: Peter Greczner, pag42@cornell.edu",15,15,15);
		drawString(10,105,"abcdefghijklmnopqrstuvwxyz", 15,15,15);
		drawString(10,120,"ABCDEFGHIJKLMNOPQRSTUVWXYZ",15,15,15);
		drawString(10,135,"1234567890-=!@#$%^&*()_+",15,15,15);
		drawString(10,150,",./;'[]<>?:\"{}",15,15,15);
		
	}
	if(test_num == 49)
	{
		setDrawMode(M8bit_DOUBLE_320x240);
		
		int k = 0;
		for(k = 0; k < 10; k ++){
		fillRectangle(0,0,320,240,0,6,0);
		frameUpdate();
		fillRectangle(0,0,320,240,0,6,0);
		frameUpdate();}
		
		int sx1 = 30;
		int sy1 = 30;
		int sx2 = 150;
		int sy2 = 50;
		int dx1 = 1;
		int dx2 = -2;
		int dy1 = 1;
		int dy2 = -1;
		int count = 0;
		char counter[10];
		int i = 0; 
		for(i = 0; i < 1000; i ++)
		{
			fillRectangle(sx2-10,sy2-3,8*16,20,0,6,0);
			fillRectangle(sx1-10,sy1-3,8*16,20,0,6,0);
			fillRectangle(10,10,50,10,0,6,0);
			drawString(sx1,sy1, "Screen Saver 1", 15,15,15);
			
			drawString(sx2,sy2, "Screen Saver 2", 15,15,15);
			
			
			sprintf(counter,"%i",count);
			drawString(10,10,counter,10,0,0);
			count ++;
			
			frameUpdate();
			
			sx1 += dx1;
			sx2 += dx2;
			sy1 += dy1;
			sy2 += dy2;
			
			if(sx1 < 10 || sx1 > (320-8*14))dx1*=-1;
			if(sx2 < 10 || sx2 > (320-8*14))dx2*=-1;
			if(sy1 < 10 || sy1 > (225))dy1*=-1;
			if(sy2 < 10 || sy2 > (225))dy2*=-1;
			
			
		
		
		}
		
		
		
		
	}
	
	return 0;
}


